<?php
namespace Claromentis\Core\User\Directory\Ldap;

$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] = (@$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] ?: array()) + array("_ca1057ad8fada1881cc7737d51fc" . "d1af" => base64_decode("VGhlIHRpbW" . "V6b25lIG9m" . "ZnNldCA="), "_995fb4acb4a30eab38e7" . "44c36dc6fb4a" => base64_decode("WW1kS" . "Glz"), "_ccaa693c4f17" . "37d3bf7611e6c" . "25e1869" => base64_decode("IGlzIGludmF" . "saWQ="), "_3db2b68627" . "d67bdfe07de" . "458cf5ea3ba" => base64_decode("c3RydG9" . "1cHBlcg" . "=="), "_3947612f1" . "a6969300a6" . "d08deec805" . "277" => base64_decode("Wg" . "=="), "_d155d43a39de93f858123c6b6ce31d" . "8a" => base64_decode("cHJlZ" . "19tYX" . "RjaA=" . "="), "_aaabebe7ea4" . "dcd24a8e6b36" . "cfe511422" => base64_decode("VV" . "RD"), "_47c50dfc8dc45a6888602c1db1a19" . "3a3" => base64_decode("IGlzIG5vdCBpbiBhIHZhbGlkIExEQVAgR2VuZXJhbGlzZWQgVGltZSBmb3" . "JtYXQ="), "_0042b42b94edac4" . "5ee46e1c7cc0e21f" . "7" => base64_decode("d" . "X" . "R" . "j"));
use Claromentis\Core\User\Directory\Exception\InvalidDateException;
use DateTime;
use DateTimeZone;
use Exception;






class GeneralizedTimeParser
{
    
    
    
    
    
    
    
    
    private $regex = '#^(\\d{14})([,.]{1}\\d+)?(Z|z|((\\+|-){1}(\\d{2}|\\d{4})))$#';
    
    
    
    
    private $parsed = null;
    
    
    
    
    private $is_utc = false;
    
    
    
    
    
    private $timezone = null;
    public function __construct($_67a0d624aebcceb0abd5ce56a53ff06f = null)
    {
        if ($_67a0d624aebcceb0abd5ce56a53ff06f) {
            $this->initWithDate($_67a0d624aebcceb0abd5ce56a53ff06f);
        }
    }
    
    
    
    
    
    
    
    public function initWithDate($_67a0d624aebcceb0abd5ce56a53ff06f)
    {
        
        
        $this->parsed = null;
        $this->timezone = null;
        $this->is_utc = false;
        
        
        $_3edeea3a30945de8abb845ca7489c82a = [];
        $GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_d155d43a3" . "9de93f8581" . "23c6b6ce31" . "d8a"]($this->regex, $_67a0d624aebcceb0abd5ce56a53ff06f, $_3edeea3a30945de8abb845ca7489c82a);
        if (empty($_3edeea3a30945de8abb845ca7489c82a)) {
            throw new InvalidDateException($_67a0d624aebcceb0abd5ce56a53ff06f . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_47c50dfc8dc45a6888602" . "c1db1a193a3"]);
        }
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_3db2b68627d67bdfe07de45" . "8cf5ea3ba"]($_3edeea3a30945de8abb845ca7489c82a[3]) === $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_3947612f1a6969300a6d08dee" . "c805277"]) {
            $this->is_utc = true;
            $this->timezone = new DateTimeZone($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_0042b42b94edac45ee46e1c7c" . "c0e21f7"]);
        }
        if (!$this->is_utc && isset($_3edeea3a30945de8abb845ca7489c82a[4])) {
            try {
                $this->timezone = new DateTimeZone($_3edeea3a30945de8abb845ca7489c82a[4]);
            } catch (Exception $_fe441aa3ef350bfb1a1a1ad8520dd530) {
                throw new InvalidDateException($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_ca1057ad8fad" . "a1881cc7737d5" . "1fcd1af"] . $_3edeea3a30945de8abb845ca7489c82a[4] . $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_ccaa693c4f1737d" . "3bf7611e6c25e186" . "9"]);
            }
        }
        $this->parsed = DateTime::createFromFormat($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_995fb4a" . "cb4a30ea" . "b38e744c" . "36dc6fb4" . "a"], $_3edeea3a30945de8abb845ca7489c82a[1], $this->timezone);
        return $this;
    }
    
    
    
    
    
    
    public function getDate() : ?DateTime
    {
        if (!$this->parsed) {
            return null;
        }
        return clone $this->parsed;
    }
    
    
    
    
    
    
    public function getUTCDate() : ?DateTime
    {
        if (!$this->parsed) {
            return null;
        }
        $_07af7964f51512e67eca70b67f086fce = clone $this->parsed;
        $_07af7964f51512e67eca70b67f086fce->setTimezone(new DateTimeZone($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_aaabebe7ea4dcd24a8e6b36c" . "fe511422"]));
        return $_07af7964f51512e67eca70b67f086fce;
    }
    
    
    
    
    
    
    public function isUTC() : bool
    {
        return $this->is_utc;
    }
}